#version 430 core

layout(location = 0) in vec2 aPos;
layout(location = 1) in vec2 aUV;

out vec2 vUV;
out vec2 vFragScreenPos;

uniform vec2 uPos;
uniform vec2 uSize;
uniform vec2 uScreen;

void main()
{
    vUV = aUV;

    vec2 worldPos = uPos + aPos * uSize;

    vFragScreenPos = worldPos;

    vec2 ndc = (worldPos / uScreen) * 2.0 - 1.0;
    ndc.y *= -1.0;

    gl_Position = vec4(ndc, 0.0, 1.0);
}
